/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAccessibilityObjectModelEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value);
}

bool WebPreferences::accessibilityObjectModelEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey());
}

void WebPreferences::setAsyncFrameScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value);
}

bool WebPreferences::asyncFrameScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey());
}

void WebPreferences::setCacheAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cacheAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cacheAPIEnabledKey(), value);
}

bool WebPreferences::cacheAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cacheAPIEnabledKey());
}

void WebPreferences::setColorFilterEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::colorFilterEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::colorFilterEnabledKey(), value);
}

bool WebPreferences::colorFilterEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::colorFilterEnabledKey());
}

void WebPreferences::setConstantPropertiesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::constantPropertiesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::constantPropertiesEnabledKey(), value);
}

bool WebPreferences::constantPropertiesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::constantPropertiesEnabledKey());
}

void WebPreferences::setCrossOriginOptionsSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::crossOriginOptionsSupportEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::crossOriginOptionsSupportEnabledKey(), value);
}

bool WebPreferences::crossOriginOptionsSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::crossOriginOptionsSupportEnabledKey());
}

void WebPreferences::setDisabledAdaptationsMetaTagEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::disabledAdaptationsMetaTagEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::disabledAdaptationsMetaTagEnabledKey(), value);
}

bool WebPreferences::disabledAdaptationsMetaTagEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::disabledAdaptationsMetaTagEnabledKey());
}

void WebPreferences::setFetchAPIKeepAliveEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value);
}

bool WebPreferences::fetchAPIKeepAliveEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey());
}

void WebPreferences::setFromOriginResponseHeaderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fromOriginResponseHeaderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fromOriginResponseHeaderEnabledKey(), value);
}

bool WebPreferences::fromOriginResponseHeaderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fromOriginResponseHeaderEnabledKey());
}

void WebPreferences::setFullScreenEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fullScreenEnabledKey(), value);
}

bool WebPreferences::fullScreenEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey());
}

void WebPreferences::setImageBitmapOffscreenCanvasEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value);
}

bool WebPreferences::imageBitmapOffscreenCanvasEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey());
}

void WebPreferences::setIsSecureContextAttributeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isSecureContextAttributeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::isSecureContextAttributeEnabledKey(), value);
}

bool WebPreferences::isSecureContextAttributeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isSecureContextAttributeEnabledKey());
}

void WebPreferences::setLinkPreloadEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::linkPreloadEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::linkPreloadEnabledKey(), value);
}

bool WebPreferences::linkPreloadEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::linkPreloadEnabledKey());
}

void WebPreferences::setMDNSICECandidatesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mDNSICECandidatesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mDNSICECandidatesEnabledKey(), value);
}

bool WebPreferences::mDNSICECandidatesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mDNSICECandidatesEnabledKey());
}

void WebPreferences::setResourceLoadStatisticsDebugMode(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value);
}

bool WebPreferences::resourceLoadStatisticsDebugMode() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey());
}

void WebPreferences::setRestrictedHTTPResponseAccess(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value);
}

bool WebPreferences::restrictedHTTPResponseAccess() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey());
}

void WebPreferences::setServerTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serverTimingEnabledKey(), value);
}

bool WebPreferences::serverTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey());
}

void WebPreferences::setServiceWorkersEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serviceWorkersEnabledKey(), value);
}

bool WebPreferences::serviceWorkersEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey());
}

void WebPreferences::setSpringTimingFunctionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value);
}

bool WebPreferences::springTimingFunctionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey());
}

void WebPreferences::setStorageAccessAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::storageAccessAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::storageAccessAPIEnabledKey(), value);
}

bool WebPreferences::storageAccessAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::storageAccessAPIEnabledKey());
}

void WebPreferences::setStorageAccessPromptsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::storageAccessPromptsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::storageAccessPromptsEnabledKey(), value);
}

bool WebPreferences::storageAccessPromptsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::storageAccessPromptsEnabledKey());
}

void WebPreferences::setSubresourceIntegrityEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::subresourceIntegrityEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::subresourceIntegrityEnabledKey(), value);
}

bool WebPreferences::subresourceIntegrityEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::subresourceIntegrityEnabledKey());
}

void WebPreferences::setVisualViewportAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value);
}

bool WebPreferences::visualViewportAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey());
}

void WebPreferences::setWebAnimationsCSSIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value);
}

bool WebPreferences::webAnimationsCSSIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey());
}

void WebPreferences::setWebAnimationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey());
}

void WebPreferences::setWebGL2Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGL2EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGL2EnabledKey(), value);
}

bool WebPreferences::webGL2Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGL2EnabledKey());
}

void WebPreferences::setWebGLCompressedTextureASTCSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value);
}

bool WebPreferences::webGLCompressedTextureASTCSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey());
}

void WebPreferences::setWebGPUEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGPUEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGPUEnabledKey(), value);
}

bool WebPreferences::webGPUEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGPUEnabledKey());
}

void WebPreferences::setWebVREnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webVREnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webVREnabledKey(), value);
}

bool WebPreferences::webVREnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webVREnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", false),
        API::ExperimentalFeature::create("Async Frame Scrolling", "AsyncFrameScrollingEnabled", "Perform frame scrolling in a dedicated thread or process", false),
        API::ExperimentalFeature::create("Cache API", "CacheAPIEnabled", "Enable Cache API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Color Filter", "ColorFilterEnabled", "Enable CSS Color Filter property", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Constant Properties", "ConstantPropertiesEnabled", "Enable CSS constant() values", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Cross-Origin-Options HTTP Header", "CrossOriginOptionsSupportEnabled", "Enable support for Cross-Origin-Options HTTP Header", true),
        API::ExperimentalFeature::create("disabled-adaptations", "DisabledAdaptationsMetaTagEnabled", "Enable the 'disabled-adaptations' meta tag", DISABLED_ADAPTATIONS_META_TAG_ENABLED),
        API::ExperimentalFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", false),
        API::ExperimentalFeature::create("From-Origin Response Header", "FromOriginResponseHeaderEnabled", "Support for the From-Origin Response Header", false),
#if ENABLE(FULLSCREEN_API)
#if PLATFORM(IOS)
        API::ExperimentalFeature::create("Fullscreen API", "FullScreenEnabled", "Fullscreen API", DEFAULT_ENABLE_FULLSCREEN_API),
#endif
#endif
        API::ExperimentalFeature::create("ImageBitmap and OffscreenCanvas", "ImageBitmapOffscreenCanvasEnabled", "Support for the ImageBitmap and OffscreenCanvas APIs", true),
        API::ExperimentalFeature::create("Secure Contexts API", "IsSecureContextAttributeEnabled", "Enable Secure Contexts API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Link Preload", "LinkPreloadEnabled", "Link preload support", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("Enable MDNS ICE candidates", "MDNSICECandidatesEnabled", "Enable MDNS ICE candidates", false),
#endif
        API::ExperimentalFeature::create("ITP Debug Mode", "ResourceLoadStatisticsDebugMode", "Intelligent Tracking Prevention Debug Mode", false),
        API::ExperimentalFeature::create("Restricted HTTP Response Access to Web Process", "RestrictedHTTPResponseAccess", "Restricted HTTP Response Access to Web Process", true),
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", false),
#if ENABLE(SERVICE_WORKER)
        API::ExperimentalFeature::create("ServiceWorkers", "ServiceWorkersEnabled", "Enable ServiceWorkers", DEFAULT_SERVICE_WORKERS_ENABLED),
#endif
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Storage Access API", "StorageAccessAPIEnabled", "Enable Storage Access API", true),
        API::ExperimentalFeature::create("Prompt for Storage Access API Requests", "StorageAccessPromptsEnabled", "Prompt the user when Storage Access API calls are made", true),
        API::ExperimentalFeature::create("SubresourceIntegrity", "SubresourceIntegrityEnabled", "Enable SubresourceIntegrity", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("VisualViewportAPI", "VisualViewportAPIEnabled", "Enable Visual Viewport API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Web Animations and CSS Integration", "WebAnimationsCSSIntegrationEnabled", "Expose CSS Animations and CSS Transitions through getAnimations()", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
        API::ExperimentalFeature::create("Web Animations", "WebAnimationsEnabled", "Web Animations prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", false),
#endif
        API::ExperimentalFeature::create("ASTC Texture Support", "WebGLCompressedTextureASTCSupportEnabled", "Support for ASTC compressed texture formats in WebGL", false),
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU prototype", false),
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        API::ExperimentalFeature::create("WebVR", "WebVREnabled", "WebVR Module support", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED),
#endif
    });

    return features;
}

bool WebPreferences::isEnabledForFeature(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::asyncFrameScrollingEnabled },
        { "CacheAPIEnabled", &WebPreferences::cacheAPIEnabled },
        { "ColorFilterEnabled", &WebPreferences::colorFilterEnabled },
        { "ConstantPropertiesEnabled", &WebPreferences::constantPropertiesEnabled },
        { "CrossOriginOptionsSupportEnabled", &WebPreferences::crossOriginOptionsSupportEnabled },
        { "DisabledAdaptationsMetaTagEnabled", &WebPreferences::disabledAdaptationsMetaTagEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
        { "FromOriginResponseHeaderEnabled", &WebPreferences::fromOriginResponseHeaderEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::fullScreenEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::imageBitmapOffscreenCanvasEnabled },
        { "IsSecureContextAttributeEnabled", &WebPreferences::isSecureContextAttributeEnabled },
        { "LinkPreloadEnabled", &WebPreferences::linkPreloadEnabled },
#if ENABLE(WEB_RTC)
        { "MDNSICECandidatesEnabled", &WebPreferences::mDNSICECandidatesEnabled },
#endif
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::resourceLoadStatisticsDebugMode },
        { "RestrictedHTTPResponseAccess", &WebPreferences::restrictedHTTPResponseAccess },
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::serviceWorkersEnabled },
#endif
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
        { "StorageAccessAPIEnabled", &WebPreferences::storageAccessAPIEnabled },
        { "StorageAccessPromptsEnabled", &WebPreferences::storageAccessPromptsEnabled },
        { "SubresourceIntegrityEnabled", &WebPreferences::subresourceIntegrityEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::webAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::webAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::webGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::webVREnabled },
#endif
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setEnabledForFeature(bool value, const API::ExperimentalFeature& feature)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::setAsyncFrameScrollingEnabled },
        { "CacheAPIEnabled", &WebPreferences::setCacheAPIEnabled },
        { "ColorFilterEnabled", &WebPreferences::setColorFilterEnabled },
        { "ConstantPropertiesEnabled", &WebPreferences::setConstantPropertiesEnabled },
        { "CrossOriginOptionsSupportEnabled", &WebPreferences::setCrossOriginOptionsSupportEnabled },
        { "DisabledAdaptationsMetaTagEnabled", &WebPreferences::setDisabledAdaptationsMetaTagEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
        { "FromOriginResponseHeaderEnabled", &WebPreferences::setFromOriginResponseHeaderEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::setFullScreenEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::setImageBitmapOffscreenCanvasEnabled },
        { "IsSecureContextAttributeEnabled", &WebPreferences::setIsSecureContextAttributeEnabled },
        { "LinkPreloadEnabled", &WebPreferences::setLinkPreloadEnabled },
#if ENABLE(WEB_RTC)
        { "MDNSICECandidatesEnabled", &WebPreferences::setMDNSICECandidatesEnabled },
#endif
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::setResourceLoadStatisticsDebugMode },
        { "RestrictedHTTPResponseAccess", &WebPreferences::setRestrictedHTTPResponseAccess },
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::setServiceWorkersEnabled },
#endif
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
        { "StorageAccessAPIEnabled", &WebPreferences::setStorageAccessAPIEnabled },
        { "StorageAccessPromptsEnabled", &WebPreferences::setStorageAccessPromptsEnabled },
        { "SubresourceIntegrityEnabled", &WebPreferences::setSubresourceIntegrityEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::setWebAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::setWebAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::setWebGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::setWebVREnabled },
#endif
    };

    const String& key = feature.key();
    
    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    setAccessibilityObjectModelEnabled(true);
    setAsyncFrameScrollingEnabled(true);
    setCacheAPIEnabled(true);
    setColorFilterEnabled(true);
    setConstantPropertiesEnabled(true);
    setCrossOriginOptionsSupportEnabled(true);
    setDisabledAdaptationsMetaTagEnabled(true);
    setFetchAPIKeepAliveEnabled(true);
    setFromOriginResponseHeaderEnabled(true);
#if ENABLE(FULLSCREEN_API)
    setFullScreenEnabled(true);
#endif
    setImageBitmapOffscreenCanvasEnabled(true);
    setIsSecureContextAttributeEnabled(true);
    setLinkPreloadEnabled(true);
#if ENABLE(WEB_RTC)
    setMDNSICECandidatesEnabled(true);
#endif
    setResourceLoadStatisticsDebugMode(true);
    setRestrictedHTTPResponseAccess(true);
    setServerTimingEnabled(true);
#if ENABLE(SERVICE_WORKER)
    setServiceWorkersEnabled(true);
#endif
    setSpringTimingFunctionEnabled(true);
    setStorageAccessAPIEnabled(true);
    setStorageAccessPromptsEnabled(true);
    setSubresourceIntegrityEnabled(true);
    setVisualViewportAPIEnabled(true);
    setWebAnimationsCSSIntegrationEnabled(true);
    setWebAnimationsEnabled(true);
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
    setWebGLCompressedTextureASTCSupportEnabled(true);
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
    setWebVREnabled(true);
#endif
}

}
